<script lang="ts">
import Vue from 'vue';
import SoftwareFasterVideoModal from './software-faster-video-modal.vue';

export default Vue.extend({
  components: {
    SoftwareFasterVideoModal,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      visibleCaseStudy: 0,
      isModalVisible: false,
      activeModalIndex: 0,
    };
  },
  watch: {
    isModalVisible(newValue) {
      if (newValue) {
        document.querySelector('body')?.classList.add('noScroll');
      } else {
        document.querySelector('body')?.classList.remove('noScroll');
        const video =
          this.$refs.videoModal[this.activeModalIndex].querySelector(
            'lite-vimeo',
          ).contentWindow;
        if (video) {
          video.postMessage('{"method":"pause"}', '*');
        }
      }
    },
  },
  methods: {
    showModal(index) {
      this.isModalVisible = true;
      this.activeModalIndex = index;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal(index) {
      this.isModalVisible = false;
      this.activeModalIndex = index;
    },
    goToNext() {
      if (this.visibleCaseStudy >= this.data.case_studies.length - 1) {
        this.visibleCaseStudy = 0;
      } else {
        this.visibleCaseStudy++;
      }
    },
    goToPrev() {
      if (this.visibleCaseStudy < this.data.case_studies.length - 2) {
        this.visibleCaseStudy = this.data.case_studies.length - 1;
      } else {
        this.visibleCaseStudy--;
      }
    },
  },
});
</script>

<template>
  <section class="section">
    <SlpContainer class="wrapper">
      <SlpTypography
        tag="h2"
        variant="heading2-bold"
        class="slp-mb-32 section__header"
        data-aos="fade-up"
        data-aos-duration="800"
        >{{ data.header }}</SlpTypography
      >
      <!-- @click.native= only works with links within this application, does not work with blog links  -->
      <div class="featured-content">
        <SlpColumn
          v-for="(case_study, index) in data.case_studies"
          :key="index"
          :index="index"
          class="featured-content__card"
          :data-aos="
            case_study.aos_animation ? case_study.aos_animation : 'fade-up'
          "
          :data-aos-duration="
            case_study.aos_duration
              ? case_study.aos_duration
              : 800 + index * 200
          "
          @click.native="
            if (!case_study.link.href) {
              showModal(index);
            }
          "
        >
          <a
            v-if="case_study.link.href"
            :href="case_study.link.href"
            :data-ga-name="case_study.link.data_ga_name"
            :data-ga-location="case_study.link.data_ga_location"
          >
            <div class="featured-content__wrap">
              <img
                :src="case_study.showcase_img.url"
                :alt="case_study.showcase_img.alt"
                class="featured-content--showcase-img slp-mb-24"
                loading="lazy"
              />
              <SlpTypography
                tag="h2"
                variant="heading5-bold"
                class="slp-mb-32"
                >{{ case_study.header }}</SlpTypography
              >
              <img
                :src="case_study.logo_img.url"
                :alt="case_study.logo_img.alt"
                class="featured-content--logo-img slp-mb-16"
                loading="lazy"
              />

              <SlpTypography tag="div" variant="body1">
                <div v-html="$md.render(case_study.description)"></div>
              </SlpTypography>
            </div>
            <div class="featured-content__link">
              <SlpTypography variant="body1-bold">{{
                case_study.link.text
              }}</SlpTypography>

              <SlpIcon
                class="learn-more__icon"
                name="chevron-lg-right"
                variant="product"
                alt="Chevron Right Icon"
              />
            </div>
          </a>
          <div v-else>
            <div class="featured-content__wrap">
              <img
                :src="case_study.showcase_img.url"
                :alt="case_study.showcase_img.alt"
                class="featured-content--showcase-img slp-mb-24"
                loading="lazy"
              />
              <SlpTypography
                tag="h2"
                variant="heading5-bold"
                class="slp-mb-32"
                >{{ case_study.header }}</SlpTypography
              >
              <img
                :src="case_study.logo_img.url"
                :alt="case_study.logo_img.alt"
                class="featured-content--logo-img slp-mb-16"
                loading="lazy"
              />

              <SlpTypography tag="div" variant="body1">
                <div v-html="$md.render(case_study.description)"></div>
              </SlpTypography>
            </div>
            <div>
              <SlpButton
                variant="tertiary"
                class="featured-content__link"
                :data-ga-name="case_study.link.data_ga_name"
                :data-ga-location="case_study.link.data_ga_location"
                @click.native="showModal(index)"
              >
                <SlpTypography variant="body1-bold">{{
                  case_study.link.text
                }}</SlpTypography>
                <SlpIcon
                  class="learn-more__icon"
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
      </div>
    </SlpContainer>

    <div
      v-for="(case_study, index) in data.case_studies"
      :key="index"
      ref="videoModal"
    >
      <div
        v-if="case_study.link.video_url"
        v-show="isModalVisible && activeModalIndex == index"
        class="modal__backdrop"
        :aria-hidden="!isModalVisible"
        @click.self="closeModal(index)"
      >
        <SoftwareFasterVideoModal
          :video-url="case_study.link.video_url"
          @close="closeModal(index)"
        />
      </div>
    </div>
  </section>
</template>

<style lang="scss" scoped>
.section {
  min-width: 100%;
  min-height: 100%;
  position: relative;
  background: $color-surface-800;

  &::before {
    content: '';
    position: absolute;
    bottom: 0;
    right: 0;
    top: 0;
    left: 0;
    background: url(/nuxt-images/solutions/infinity-icon-cropped.svg) right 0/115%
      no-repeat;

    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }

  &__header {
    position: relative;

    @media (max-width: $breakpoint-md) {
      padding-left: $spacing-16;
    }
  }
}

.wrapper {
  background: $color-surface-800;
  padding-top: $spacing-48;
  padding-bottom: $spacing-48;
}

.featured-content {
  display: grid;
  grid-template-columns: 1fr;
  gap: 30px;
  padding: $spacing-24 0;

  @media (min-width: $breakpoint-lg - 1) {
    grid-template-columns: 1fr 1fr 1fr;
    padding: 0 0 $spacing-96 0;
    margin: 0;
  }

  &__wrap {
    flex-basis: 100%;
  }

  &__card {
    color: inherit;
    display: flex;
    border-radius: 4px 4px 4px 4px;
    flex-direction: column;
    align-items: flex-start;
    padding: 40px;
    margin: 0 auto;
    width: 100%;
    isolation: isolate;
    background: linear-gradient(
      141.57deg,
      #ffffff 0.86%,
      rgba(255, 255, 255, 0) 99.96%
    );
    z-index: 1;
    position: relative;
    cursor: pointer;

    &:before {
      position: absolute;
      content: '';
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      background: linear-gradient(141.56deg, #fff 100%, #fff 100%);
      z-index: -1;
      transition: all 0.3s ease-in-out;
      opacity: 0;
      border-radius: 4px 4px 4px 4px;
    }

    &:hover:before {
      opacity: 1;
      border-radius: 4px 4px 100px 4px;
    }

    > a {
      color: $color-primary-200;
    }
  }

  &__text {
    flex-basis: 100%;
    .icon {
      width: 32px;
      height: 32px;
    }
  }

  &__link {
    color: $color-text-link-100;
    padding-left: 0;
    margin-top: 24px;
    &:hover {
      text-decoration-color: $color-text-link-100;
    }

    &:not(button) {
      display: inline-flex;
      align-items: center;

      .slp-icon {
        transform: translateX(4px);
        transition: transform 0.2s ease-in-out;
      }

      &:hover {
        text-decoration: underline;

        .slp-icon {
          transform: translateX(8px);
        }
      }
    }
  }

  &--showcase-img {
    max-width: 100%;
  }

  &--logo-img {
    max-height: 24px;
  }
}
.case-studies {
  &__card {
    display: flex;
    position: relative;
    border-radius: 4px;
    padding: 32px;
    flex-direction: column;
    align-items: flex-start;
    isolation: isolate;
    background: white;

    @media (max-width: $breakpoint-md) {
      margin: 0 $spacing-16;
    }

    :deep(strong) {
      font-weight: $font-weight-bold;
    }

    &--showcase-img {
      max-width: 100%;
    }

    &--logo-img {
      max-height: 24px;
      margin-bottom: 32px;
    }
  }
}

.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;

  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
  }
}
</style>
